//@ sourceURL=tabSolicitudBajaPapel0.js
/*!
 * Copyright 2021 E.J.I.E., S.A.
 *
 * Licencia con arreglo a la EUPL, Versión 1.1 exclusivamente (la "Licencia");
 * Solo podrá usarse esta obra si se respeta la Licencia.
 * Puede obtenerse una copia de la Licencia en
 *
 *      http://ec.europa.eu/idabc/eupl.html
 *
 * Salvo cuando lo exija la legislación aplicable o se acuerde por escrito,
 * el programa distribuido con arreglo a la Licencia se distribuye "TAL CUAL",
 * SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
 * Véase la Licencia en el idioma concreto que rige los permisos y limitaciones
 * que establece la Licencia.
 */

jQuery(function($) {
	

	initRupI18nPromise.then(function() {
		initTab();
		init();
		initComponentes();
	});
	const initTab = () => {
		$.rup_ajax({
   		 	type:  "GET",
  	        url: $.rup.CTX_PATH + 'expedientes/' +  $('#idExpediente00TabSolicitud').val(),
            contentType: 'application/json',
            beforeSend: function(){
           	Ad74aUtils.cerrarFeedbacks();
				Ad74aUtils.bloquearInterfaz();
			},
			success: function(res){
				expedientes = res;
				expedienteJSON = JSON.parse(res);
				

				//obligatorio
//				$("#dirContactoidprovincia06_detail_table_label").attr('required','required');
//				$("#dirContactoidmunicipio06_detail_table_label").attr('required','required');
//				$("#dirContactoidlocalidad06_detail_table_label").attr('required','required');
//				$("#dirContactoidcalle06_detail_table_label").attr('required','required');
//				$("#dirContactoidportal06_detail_table_label").attr('required','required');
				$("label[for='dirContactocp06_detail_table']").addClass('obligatorio');
				$("label[for='dirContactoidprovincia06_detail_table_label']").addClass('obligatorio');
				$("label[for='dirContactoidmunicipio06_detail_table_label']").addClass('obligatorio');
				$("label[for='dirContactoidlocalidad06_detail_table_label']").addClass('obligatorio');
				$("label[for='dirContactolocalidad06_detail_table']").addClass('obligatorio');
				$("label[for='dirContactoidcalle06_detail_table_label']").addClass('obligatorio');
				$("label[for='dirContactocalle06_detail_table']").addClass('obligatorio');
//				$("label[for='dirContactoidportal06_detail_table_label']").addClass('obligatorio');
				
				iniciarDireccionNotificacion(expedienteJSON.direccionNotif, "dirNot");
				},
				error: function(error){
					console.log("entro en error" + JSON.stringify(error));
					$("#tabSolicitud_form_feedback").rup_feedback('set',error.responseText.replaceAll("\"",""),"error");
				},
				complete: function(){
					Ad74aUtils.desBloquearInterfaz();
				}
  	    });	
	}
		
	const init = () => {
		
		$("#tabSolicitud_form_feedback").rup_feedback ({
		  type: "ok",
		  delay: 3000,
		  fadeSpeed: 600,
		  block: false
		});

		Ad74aUtils.hacerPlegable();
		Ad74aUtils.soloNumericos();
		
		
		/*
		 * BLOQUE PARA GESTIONAR EL TIPO DE PERSONA DEL REPRESENTANTE (EN SOLICITUDES DE PAPEL0)
		 */
		$('.personaFisicaGrupo').hide();
		$("#razonSocialGrupo").hide();				
		if($("#tipoIdentificadorRep00_tabSolicitud_detail_table").length > 0){
			let tipoPersona = $("#Jur_tipoRep00_tabSolicitud_detail_table").is(':checked')? tipoPersonaJuridica:tipoPersonaFisica;
			if(tipoPersona == tipoPersonaFisica){
				$('#Fis_tipoRep00_tabSolicitud_detail_table').prop("checked",true);//Chequear radio si no venia chequeado
				$('.personaFisicaGrupo').show();
				$("#razonSocialGrupo").hide();
			}else{
				$('.personaFisicaGrupo').hide();
				$("#razonSocialGrupo").show();
			}
			//Se guarda el valor actual del campo tipoIdentificadorRep00, para setearlo una vez se refresca el combo:
			const _valorTipoIdentificadorRep00 = $("#tipoIdentificadorRep00_tabSolicitud_detail_table").val();
			$("#tipoIdentificadorRep00_tabSolicitud_detail_table").rup_combo({
				source: $.rup.CTX_PATH + 'combo/tipoIdentificador?tipoPersona=' + tipoPersona,
				sourceParam: {label: "descripcion", value:"value"},
				width: 'auto',
		        ordered: false,
				customClasses: ['select-material'],
				rowStriping: true,
				blank: '',
				onLoadSuccess: function(obj){
					//Se vuelve a setear el valor que tenia antes de recargarse:
						$("#tipoIdentificadorRep00_tabSolicitud_detail_table").rup_combo("refresh");
					$("#tipoIdentificadorRep00_tabSolicitud_detail_table").rup_combo("select", _valorTipoIdentificadorRep00);
					}
			});
			
		}
		const  fisicaJuridica = () => {
			let tipoPersona = $("#Jur_tipoRep00_tabSolicitud_detail_table").is(':checked')? tipoPersonaJuridica:tipoPersonaFisica;
			if(tipoPersona == tipoPersonaFisica){//Ocultar/mostrar capas en base a la seleccion
				$('.personaFisicaGrupo').show();
				$("#razonSocialGrupo").hide();
			}else{
			$('.personaFisicaGrupo').hide();
				$("#razonSocialGrupo").show();
			}
			if(tipoPersona != undefined && tipoPersona != ''){
				$("#tipoIdentificadorRep00_tabSolicitud_detail_table").rup_combo("setSource", $.rup.CTX_PATH + 'combo/tipoIdentificador?tipoPersona=' + tipoPersona); 
			}else{
				$("#tipoIdentificadorRep00_tabSolicitud_detail_table").rup_combo("setSource", $.rup.CTX_PATH + 'combo/tipoIdentificador'); 
			}
			$("#tipoIdentificadorRep00_tabSolicitud_detail_table").rup_combo("reload");	
		}
		$("[name='tipoRep00']").change(fisicaJuridica);
		if($('#tipoIdentificadorRep00_tabSolicitud_detail_table').val()==null){
			$('#tipoIdentificadorRep00_tabSolicitud_detail_table').prop("disabled",true);
		}

		/* FIN BLOQUE PARA GESTIONAR EL TIPO DE PERSONA DEL REPRESENTANTE (EN SOLICITUDES DE PAPEL0) */
		
		
		
		// Borrar los hidden generados con el <form:checkbox/>
		$("input[name='_urgencia00']").remove();
		$("input[name='_isurgencia']").remove();
		$("input[name='_seOpone00']").remove();

		$("#recibirDatosUsuario").on("click",FN_recibirDatosUsuario_NISAE);
	}
	
	const initComponentes = () => {
		$('#origenCabecera_resumen').text(origenCabecera)
		$('#fregistroCabecera_resumen').text(fregistroCabecera)
		$('#nregistroCabecera_resumen').text(nregistroCabecera)
		$('#fRegistroOtro00_tabSolicitud_detail_table').prop("disabled",false);
		$('#numRegistroOtro00_tabSolicitud_detail_table').prop("disabled",false);
		$('#fregistroOrigenCabecera_resumen').text(fregistroOrigenCabecera)
		$('#nregistroOrigenCabecera_resumen').text(nregistroOrigenCabecera)
		
		// Comprobar si el identificador es el por defecto usado al crear el expediente desde la bandejaP0
		if( IDENTIFICADOR_DEFECTO == $("#identificador01_tabSolicitud_detail_table").val()) {
			$("#identificador01_tabSolicitud_detail_table").val("");
		}
		
		$('#fNacimiento01_tabSolicitud_detail_table').rup_date({
			yearRange: '1900:c',
			mask: 'dd/mm/yyyy',
			showButtonPanel : true,
			showOtherMonths : true,
		});
		$('#fRegistroOtro00_tabSolicitud_detail_table').rup_date({
			datetimepicker:true,
			placeholderMask : true,
			mask: 'dd-MM-yyyy HH:mm:ss.S',
	        showSecond:true,
			showButtonPanel : true,
			showOtherMonths : true,
	        dateFormat: 'dd/mm/yy',
	        timeFormat: 'HH:mm:ss'
		});
		Ad74aUtils.configCombo($("#urgenciaDetailPapel0"), {
			loadFromSelect: true,
			ordered: true,
			onLoadSuccess: function(obj){
				$('#urgenciaDetailPapel0').rup_combo('refresh');
			}
		});	

		$('#fRegistro00_tabSolicitud_detail_table').rup_date({
			datetimepicker:true,
			placeholderMask : true,
			mask: 'dd-MM-yyyy HH:mm:ss.S',
	        showSecond:true,
			showButtonPanel : true,
			showOtherMonths : true,
	        dateFormat: 'dd/mm/yy',
	        timeFormat: 'HH:mm:ss'
		});
		$("#fRegistro00_tabSolicitud_detail_table").rup_date("disable");
		$("#tipoIdentificador01_tabSolicitud_detail_table option[value='"+tipoIdentCIFVal+"']").remove();
		$("#tipoIdentificador01_tabSolicitud_detail_table").rup_combo({
			loadFromSelect:true,
			width: 'auto',
	        ordered: false,
			customClasses: ['select-material'],
			rowStriping: true,
			blank: '',
			onLoadSuccess: function(obj){
				let comboValue = $('#tipoIdentificador01_tabSolicitud_detail_table').find(":selected").val();
				$("#tipoIdentificador01_tabSolicitud_detail_table").rup_combo("clear");
				$("#tipoIdentificador01_tabSolicitud_detail_table").rup_combo("select", comboValue);
			}
		});
		Ad74aUtils.FN_controlMaxDni($("#tipoIdentificador01_tabSolicitud_detail_table"),$("#identificador01_tabSolicitud_detail_table"));
		
		$("#tipoIdentificador01_tabSolicitud_detail_table").on("change", function() { 
			Ad74aUtils.FN_controlMaxDni($("#tipoIdentificador01_tabSolicitud_detail_table"),$("#identificador01_tabSolicitud_detail_table"));
		});
		
		// Validaciones sobre campos de representante
		Ad74aUtils.FN_controlMaxDni($("#tipoIdentificadorRep00_tabSolicitud_detail_table"),$("#identificadorRep00_tabSolicitud_detail_table"));
		$("#tipoIdentificadorRep00_tabSolicitud_detail_table").on("change", function() { 
			Ad74aUtils.FN_controlMaxDni($("#tipoIdentificadorRep00_tabSolicitud_detail_table"),$("#identificadorRep00_tabSolicitud_detail_table"));
		});
		
		$("#identificadorRep00_tabSolicitud_detail_table").blur(function() { 
			$("#tabSolicitud_form").validate().element('#tipoIdentificadorRep00_tabSolicitud_detail_table');
			$("#tabSolicitud_form").validate().element('#identificadorRep00_tabSolicitud_detail_table');
		});
		
		$("#idMotivoBaja00_tabSolicitud_detail_table").rup_combo({
			loadFromSelect:true,
			width: 'auto',
	        ordered: false,
			customClasses: ['select-material'],
			rowStriping: true,
			blank: '',
			onLoadSuccess: function(obj){
				let comboValue = $('#idMotivoBaja00_tabSolicitud_detail_table').find(":selected").val();
				$("#idMotivoBaja00_tabSolicitud_detail_table").rup_combo("clear");
				$("#idMotivoBaja00_tabSolicitud_detail_table").rup_combo("select", comboValue);
			}
		});		
			
		 /***********************************/
		 /* CONTROL VISUALIZACION DE CAMPOS */
		 /***********************************/		
		
		FN_controlInteroperabilidad();
		$('#seOpone00_tabSolicitud_detail_table').change(FN_controlInteroperabilidad);
		
		FN_controlTipoNot00();
		$("[name='idTipoNot00']").change(FN_controlTipoNot00);
		FN_controlUrgencia();
		$('#urgencia00_tabSolicitud_detail_table').on("change", FN_controlUrgencia);
		FN_controlCanalNot();
		$("[name='canalNot00']").change(FN_controlCanalNot);
		
		FN_controlRepresentante();
		$("[name='presentaSol00']").change(FN_controlRepresentante );
		$("#tabSolicitud_guardar").on("click", guardarTabSolicitud);
		
		
		
		///Limitar el lenght
		$("#tipoIdentificador01_tabSolicitud_detail_table").on("change", function() { 
			Ad74aUtils.FN_controlMaxDni($("#tipoIdentificador01_tabSolicitud_detail_table"),$("#identificador01_tabSolicitud_detail_table"));
		});
 
		 
		 jQuery.validator.addMethod("requiredCPNot", function(value, element, params) {
			 if($("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
				 if(params.length != 2) {
					 return false;
				 }
				 const current 	= $("[name='"+ params[0]+"']").val();
				 const compareTo = $("[name='"+ params[1]+"']").val();
				 return (current!= "" && compareTo == "") || compareTo != "";	
			 }
			 return true;
		 }, $.rup.i18n.base.rup_validate.messages.required);
		
		 
		 jQuery.validator.addMethod("requiredNot", function(value, element,a) {
			 if(!$("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
				 return true;
			 }			 
			 return value != "" && value != null && value != undefined;
		 },$.rup.i18n.base.rup_validate.messages.required);
		 
		 jQuery.validator.addMethod("requiredPortalNot", function(value, element,a) {
			 if($("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
				 if(element.id == 'dirNotportal06_detail_table' && ($("#dirNotportal06_detail_table").val() == '' || $("#dirNotidportal06_detail_table").rup_combo("getRupValue") != '')){
					 return false;
				 }else if(element.id == 'dirNotidportal06_detail_table' && $("#dirNotidportal06_detail_table").rup_autocomplete("getRupValue") == '' && $("#dirNotportal06_detail_table").val() == '' ){
					 return false;
				 }else {
					 return true;
				 }
			 }			 		 
			 return true;
		 },$.rup.i18n.base.rup_validate.messages.required);
		 
 
		 
		 jQuery.validator.addMethod("requiredCalleNot", function(value, element,a) {
			 if($("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
				 if(element.id == 'dirNotcalle06_detail_table' && ($("#dirNotcalle06_detail_table").val() == '' || $("#dirNotidcalle06_detail_table").rup_combo("getRupValue") != '')){
					 return false;
				 }else if(element.id == 'dirNotidcalle06_detail_table' && $("#dirNotidcalle06_detail_table").rup_autocomplete("getRupValue") == '' && $("#dirNotcalle06_detail_table").val() == '' ){
					 return false;
				 }else {
					 return true;
				 }
			 }			 
			 return true;
		 },$.rup.i18n.base.rup_validate.messages.required);
		  
		///Validaciones de identificador
		jQuery.validator.addMethod("validarIdentificadorPInteresada", function(value, element,a) {
			 return Ad74aUtils.validarCampoIdentificador($("#tipoIdentificador01_tabSolicitud_detail_table").val(),$("#identificador01_tabSolicitud_detail_table").val());	
		}, $.rup.i18n.app.errores.dniNoValido);
		
		jQuery.validator.addMethod("validarIdentificadorPRepresentante", function(value, element,a) {
			 return Ad74aUtils.validarCampoIdentificador($("#tipoIdentificadorRep00_tabSolicitud_detail_table").val(),$("#identificadorRep00_tabSolicitud_detail_table").val());	
		}, $.rup.i18n.app.errores.dniNoValido);
		
		$("#tabSolicitud_form").rup_validate({
			feedback:$("#solicitud_form_feedback"),
				liveCheckingErrors: false,
				showFieldErrorAsDefault: true,
				showErrorsInFeedback: true,
				showFieldErrorsInFeedback: true,
			 rules:{
			      "solicitantes.tipoIdentificador01":{required:true},
			      "solicitantes.identificador01":{validarIdentificadorPInteresada:true,required:true},
			      "tipoIdentificadorRep00":{required:true},
			      "identificadorRep00":{validarIdentificadorPRepresentante:true},
			      "solicitantes.fNacimiento01":{date:true},
			      "emailNot00":{email:true},
//				  "direccionNotif.localidad06":{ /*requiredNot : true,*/requiredCPNot: ["direccionNotif.localidad06", "direccionNotif.idLocalidad06"]},
//				  "direccionNotif.idLocalidad06":{ /*requiredNot : true,*/requiredCPNot: ["direccionNotif.idLocalidad06", "direccionNotif.localidad06"]},
				  "idiomaNot00":{required:true},
				  "direccionNotif.cp06":{required:true},
			      "direccionNotif.idProvincia06_label":{
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked');
			    	  }
			      },
			      "direccionNotif.idMunicipio06_label":{
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked');
			    	  }
			      },
			      "direccionNotif.localidad06":{ 
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked') && $("[name='direccionNotif.idLocalidad06_label']").val()=='';
			    	  }
			      },       
				  "direccionNotif.idLocalidad06_label":{
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked') && $("[name='direccionNotif.localidad06']").val()=='';
			    	  }
			      },
			      "direccionNotif.calle06":{ 
			    	  required:function(){
			    		  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked') && $("[name='direccionNotif.idCalle06_label']").val()=='';
			    	  }
			      },   
				  "direccionNotif.idCalle06_label":{
					  required:function(){
						  return $("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked') && $("[name='direccionNotif.calle06']").val()=='';
						  }
			      }, 
			      
			 },
		});
		
		$("#tabSolicitud_form [ruptype='date']").blur(function(elem) { 

			if(!$(elem.target).valid()){
                $(elem.target).val('')
            }

		})
		
		$("#identificador01_tabSolicitud_detail_table").blur( function() { 
			$("#tabSolicitud_form").validate().element('#tipoIdentificador01_tabSolicitud_detail_table');
			$("#tabSolicitud_form").validate().element('#identificador01_tabSolicitud_detail_table');
			if($("#identificador01_tabSolicitud_detail_table").valid()){
				FN_comprobarSolicitante();
			}/*else{
				$("#apellido101_tabSolicitud_detail_table").val("");
				$("#apellido201_tabSolicitud_detail_table").val("");
				$("#nombre01_tabSolicitud_detail_table").val("");
				$("#fNacimiento01_tabSolicitud_detail_table").val("");
				$('input[name="solicitantes.sexo01"]').removeAttr("checked");
			}*/
			
		});		
		
		// Dirección de notificación
//		$("#dirNotcp06_detail_table").on('focusout', () => {
//			//$("#tabSolicitud_form").validate().element('#dirNotcp06_detail_table');
////			if($('#dirNotcp06_detail_table').valid() && $("#dirNotcp06_detail_table").val() != $("#dirNotcp06_detail_table").data('prev')){				
//			if($("#dirNotcp06_detail_table").val() != $("#dirNotcp06_detail_table").data('prev')){				
//				iniciarDireccionNotificacion(
//					{
//						"idProvincia06": $('#dirNotcp06_detail_table').val().substring(0,2)
//					},
//					"dirNot"
//				);
//				$("#dirNotcp06_detail_table").data('prev', $("#dirNotcp06_detail_table").val());
//			}						
//		});		
		//iniciarDireccionNotificacion(expedienteJSON.direccionNotif, "dirNot");
	}
		
	const guardarTabSolicitud = () => {
		
		Ad74aUtils.cerrarFeedbacks();
    	$("#tabSolicitud_form").rup_validate("resetElements");
    	let data = {};
    	data.expediente = $("#tabSolicitud_form").rup_form("formToJson");
    	data.finalizar = false;
    	//data = $("#tabSolicitud_form").rup_form("formToJson");
    	
			$.rup_ajax({
	    		 type:  "PUT",
	   	         url: $.rup.CTX_PATH + 'bandejapapel0/tabSolicitud/edit',
	   	         data: JSON.stringify(data),
	             contentType: 'application/json',
	             beforeSend: function(){
	            	Ad74aUtils.cerrarFeedbacks();
					Ad74aUtils.bloquearInterfaz();
				},
				success: function(res){
					try {
						$("#tabSolicitud_form_feedback").rup_feedback("destroy");
					} catch (error) {}

					$("#tabSolicitud_form_feedback").rup_feedback(
						{
							type: "ok",
							block: false,
							delay: 3000,
							fadeSpeed: 600,
						}
					);
					console.log("entro en success");
					
					res = JSON.parse(res);
					$("#idDireccion06NotifTabSolicitud").val(res.direccionNotif.idDireccion06);
					$("#idSolicitante01TabSolicitud").val(res.solicitantes.idSolicitante01);
						
						
						
					$("#tabSolicitud_form_feedback").rup_feedback('set',$.rup.i18n.app.feedback.modificadoOK,'ok');
					},
					error: function(error){
						console.log("entro en error" + JSON.stringify(error));
						$("#tabSolicitud_form_feedback").rup_feedback('set',error.responseText.replaceAll("\"",""),"error");
					},
					complete: function(){
						Ad74aUtils.desBloquearInterfaz();
					}
	   	    });	 
    	
	};
	
	const FN_controlInteroperabilidad = () => {
		if($('#seOpone00_tabSolicitud_detail_table').is(':checked')){
			$('#recibirDatosUsuario').prop('disabled',true);
		}else{
			$('#recibirDatosUsuario').prop('disabled',false);
		}
	}
	
	function FN_controlTipoNot00(){
		if($("#T_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
			
			
			$("#divDireccionNot").hide();
//			$('#dirNotcp06_detail_table').removeAttr("required");
//			$('#dirNotidprovincia06_detail_table').removeAttr("required");
//			$('#dirNotidmunicipio06_detail_table').removeAttr("required");
//			$('#dirNotidlocalidad06_detail_table').removeAttr("required");
//			$('#dirNotidcalle06_detail_table').removeAttr("required");
			$("label[for='dirNotcp06_detail_table']").removeClass('obligatorio');
			$("label[for='dirNotidprovincia06_detail_table_label']").removeClass('obligatorio');
			$("label[for='dirNotidmunicipio06_detail_table_label']").removeClass('obligatorio');
			$("label[for='dirNotidlocalidad06_detail_table_label']").removeClass('obligatorio');
			$("label[for='dirNotlocalidad06_detail_table']").removeClass('obligatorio');
			$("label[for='dirNotidcalle06_detail_table_label']").removeClass('obligatorio');
			$("label[for='dirNotcalle06_detail_table']").removeClass('obligatorio');
		}else if($("#P_idTipoNot00_tabSolicitud_detail_table").is(':checked')){
			
			
			$("#divDireccionNot").show();
//			$('#dirNotcp06_detail_table').attr("required","required");
//			$('#dirNotidprovincia06_detail_table').attr("required","required");
//			$('#dirNotidmunicipio06_detail_table').attr("required","required");
			$("label[for='dirNotcp06_detail_table']").addClass('obligatorio');
			$("label[for='dirNotidprovincia06_detail_table_label']").addClass('obligatorio');
			$("label[for='dirNotidmunicipio06_detail_table_label']").addClass('obligatorio');
			$("label[for='dirNotidcalle06_detail_table_label']").addClass('obligatorio');
			$("label[for='dirNotcalle06_detail_table']").addClass('obligatorio');
			
			$("label[for='dirNotidlocalidad06_detail_table_label']").addClass('obligatorio');
			$("label[for='dirNotlocalidad06_detail_table']").addClass('obligatorio');
			//$('#dirNotidlocalidad06_detail_table').attr("required","required");
			//$('#dirNotidcalle06_detail_table').attr("required","required");
		}
	}
	
	const FN_controlCanalNot = () => {
		
		if($("#A_canalNot00_tabSolicitud_detail_table").is(':checked')){
			$("#tlfnNotGrupo").show();
			$("#emailNotGrupo").show();
		}if($("#E_canalNot00_tabSolicitud_detail_table").is(':checked')){
			$("#emailNotGrupo").show();
			$("#tlfnNotGrupo").hide();
		}if($("#S_canalNot00_tabSolicitud_detail_table").is(':checked')){
			$("#tlfnNotGrupo").show();
			$("#emailNotGrupo").hide();
		}
	
	}
	
	const FN_comprobarSolicitante = () => {
		Ad74aUtils.pintarAvisoInteroperabilidad("aviso_usuario", "", "");
		const identificadorSolicitante = $("#identificador01_tabSolicitud_detail_table").val();
		if(identificadorSolicitante  != null && identificadorSolicitante.trim() != ''){
			$.rup_ajax({
	   		 	type:  "POST",
	  	        url: $.rup.CTX_PATH + 'bandejapapel0/existeSolicitante/' + identificadorSolicitante + '/' +idProcedimiento00 ,
	            contentType: 'application/json',
	            beforeSend: function(){
	           	Ad74aUtils.cerrarFeedbacks();
					Ad74aUtils.bloquearInterfaz();
				},
				success: function(res){
					console.log(res);
					if(res == 0){
						Ad74aUtils.pintarAvisoInteroperabilidad("aviso_usuario", "nook", "El solicitante no existe como beneficiario");
					}else if(res == 2){
						Ad74aUtils.pintarAvisoInteroperabilidad("aviso_usuario", "warning", "Existe un expediente abierto del mismo tipo para el beneficiario indicado.");
						FN_recibirBeneficiario();
					}else if(res == 3){
						Ad74aUtils.pintarAvisoInteroperabilidad("aviso_usuario", "warning", "El solicitante existe como beneficiario dado de baja");
						FN_recibirBeneficiario();
					}else{
						
						Ad74aUtils.pintarAvisoInteroperabilidad("aviso_usuario", "warning", "");
						FN_recibirBeneficiario();
					}
				},
				error: function(error){
					Ad74aUtils.pintarAvisoInteroperabilidad("aviso_usuario", "nook", error.responseJSON.replaceAll("\"",""));
					Ad74aUtils.desBloquearInterfaz();
				},
				complete: function(){
					Ad74aUtils.desBloquearInterfaz();
				}
	  	    });		 
		}
	}
	
	const FN_recibirBeneficiario = () => {
		$.rup_ajax({
            url: $.rup.CTX_PATH +"inicioOficio/obtenerDatosBeneficiario/"+ $("#identificador01_tabSolicitud_detail_table").val() ,
            type: "POST",    
   			       
            dataType: 'json',
            contentType: 'application/json',
				beforeSend: function() {
					Ad74aUtils.bloquearInterfaz();
              },
              complete: function() {
              	//Sólo se desbloquea al fallar para prevenir doble click	                	
              },
            success: function (data){
				
				$('#idSolicitante01_informes_dialog_table').val('');
				$('#nombre01_tabSolicitud_detail_table').val('');
		        $('#apellido101_tabSolicitud_detail_table').val('');
		        $('#apellido201_tabSolicitud_detail_table').val('');
				if(data.idSolicitante01!=null){
					$('#nombre01_tabSolicitud_detail_table').val(data.nombre01);
		            $('#apellido101_tabSolicitud_detail_table').val(data.apellido101);
			        $('#apellido201_tabSolicitud_detail_table').val(data.apellido201);
			        $("#fNacimiento01_tabSolicitud_detail_table").val(data.fNacimiento01);
                    if(data.sexo01 == 'M'){
                        $("#H_sexo01_tabSolicitud_detail_table").click()
                    }else{
                        $("#M_sexo01_tabSolicitud_detail_table").click()
                    }

					$('.datosNuevoBeneficiario').hide();
					$('.datosBeneficiario').show();
					
				}
				Ad74aUtils.desBloquearInterfaz();
            },
            error: function(error){ 
				Ad74aUtils.desBloquearInterfaz();
				$("#tabSolicitud_form_feedback").rup_feedback('set', error.responseText, "error");			      }

      });	 
	}
	function FN_controlUrgencia() {
	    // Comprobamos si el checkbox está seleccionado
	    if ($('#urgencia00_tabSolicitud_detail_table').is(':checked')) {
	        // Si el checkbox está seleccionado, mostramos el select
	        $('#urgenciaLayer').show();
	    } else {
	        // Si no está seleccionado, ocultamos el select
	        $('#urgenciaLayer').hide();
	        if($("#urgenciaDetailPapel0").val() != ''){
	        	 $("#urgenciaDetailPapel0").rup_combo("clear");
	        }
	       
	    }
	}
	const FN_controlRepresentante = () => {
		var quienPresentaSol = $("[name='presentaSol00']:checked").val();
		if (quienPresentaSol == 0 || quienPresentaSol == undefined){
			$("#tipoIdentificadorRep00_tabSolicitud_detail_table").removeAttr("required");
			$("#identificadorRep00_tabSolicitud_detail_table").removeAttr("required");
			$("#identificadorRep00_tabSolicitud_detail_table").removeAttr("required");
			$("#camposRepresentante").hide();
		}else {
			
			$("#tipoIdentificadorRep00_tabSolicitud_detail_table").attr("required","required");
			$("#identificadorRep00_tabSolicitud_detail_table").attr("required","required");
			$("#identificadorRep00_tabSolicitud_detail_table").attr("required","required");
			$("#camposRepresentante").show();
		}
		
	}
	
	const FN_recibirDatosUsuario_NISAE = () => {
	    const identificadorSolicitante = $("#identificador01_tabSolicitud_detail_table").val(); 
	    const apellidoSolicitante = $("#apellido101_tabSolicitud_detail_table").val(); 
	    const fNacimientoSolicitante = $("#fNacimiento01_tabSolicitud_detail_table").val(); 
	    const tipoIden = $("#tipoIdentificador01_tabSolicitud_detail_table").val();
	    const url = $.rup.CTX_PATH + "recibirDatosNISAE/getDatosDGPInterop"; 
	    let data = {};
	    data.identificadorSolicitante = identificadorSolicitante;
	    data.idExpediente = $("#idExpediente00TabSolicitud").val();
	    data.tipoIden = tipoIden;
	    
	    if(apellidoSolicitante != ''){
	        data.apellidoSolicitante = apellidoSolicitante;
	    }
	    if(fNacimientoSolicitante != ''){
	        data.fNacimientoSolicitante = fNacimientoSolicitante;
	    }
	    
	    data = JSON.stringify(data);
	    Ad74aUtils.pintarAvisoInteroperabilidad("aviso_usuario", "", "");
	    if(identificadorSolicitante != '' && (apellidoSolicitante != '' || fNacimientoSolicitante != '')){
	         $.rup_ajax({
	                url: url,
	                type: 'POST',
	                data: data,
	                contentType: 'application/json',
	                dataType: 'json',
	                beforeSend: () => {
	                    $("#recibirDatosUsuario i").removeClass("mdi-file-send-outline");
	                    $("#recibirDatosUsuario i").addClass("mdi-spin mdi-loading");
	                    $("#recibirDatosUsuario").prop("disabled", true);
	                },
	                success: function (res) {
	                	console.log("#####ResultadoInteroperabilidad");
						console.log(res);
						let clase = "ok"
						if (res.codResultado == 1) {
							clase = "warning"
						}else if(res.codResultado == 2) {
							clase = "nook";
						}
						Ad74aUtils.pintarAvisoInteroperabilidad("aviso_usuario", clase, res.mensaje);
	                    
						if(res.codResultado == 0){
	                    	const datosDGP = res.resultadoDGP;
	                        $("#nombre01_tabSolicitud_detail_table").val(datosDGP.nombre01);
	                        $("#apellido101_tabSolicitud_detail_table").val(datosDGP.apellido101);
	                        $("#apellido201_tabSolicitud_detail_table").val(datosDGP.apellido201);
	                        $("#fNacimiento01_tabSolicitud_detail_table").val(datosDGP.fNacimiento01);
	                        if(datosDGP.sexo01 == 'M'){
	                            $("#H_sexo01_tabSolicitud_detail_table").click()
	                        }else{
	                            $("#M_sexo01_tabSolicitud_detail_table").click()
	                        }
	                    }
	                },
	                error: function (error) {
                		Ad74aUtils.pintarAvisoInteroperabilidad("aviso_usuario", "nook", error);
	                },
	                complete: () => {
	                    $("#recibirDatosUsuario i").removeClass("mdi-spin mdi-loading");
	                    $("#recibirDatosUsuario i").addClass("mdi-file-send-outline");
	                    $("#recibirDatosUsuario").prop("disabled", false);
	                }
	            });
	    }else {
	    	Ad74aUtils.pintarAvisoInteroperabilidad("aviso_usuario", "nook", $.rup.i18n.app.errores.verificarIdentidadTipoError);
	    }
	    
	}
	
	const convertirFecha = (fecha) => {
	    // Verificar que la fecha tenga el formato correcto (8 dígitos)
	    if (fecha.length !== 8 || isNaN(fecha)) {
	        return "Formato de fecha inválido. Debe ser YYYYMMDD (8 dígitos).";
	    }

	    // Separar el año, mes y día
	    const year = fecha.slice(0, 4);
	    const month = fecha.slice(4, 6);
	    const day = fecha.slice(6, 8);

	    // Crear un nuevo string con el formato DD/MM/YYYY
	    const fechaFormateada = `${day}/${month}/${year}`;

	    return fechaFormateada;
	}
	
	const iniciarDireccionNotificacion = (direccion, prefix) => {
		
		// Mostrar/ocultar los datos alternativos inicialmente
		if($("#"+prefix+"idlocalidad06_detail_table").val() == ''){						
			$("#"+prefix+"localidadDesc").show();
			$("#"+prefix+"calleDesc").show();
			$("#"+prefix+"portalDesc").show();
		}else{
			$("#"+prefix+"localidadDesc").hide();
		}
		
		if($("#"+prefix+"idcalle06_detail_table").val() == ''){						
			$("#"+prefix+"calleDesc").show();
			$("#"+prefix+"portalDesc").show();
		}else{
			$("#"+prefix+"calleDesc").hide();
		}
		
		if($("#"+prefix+"idportal06_detail_table").val() == ''){
			$("#"+prefix+"portalDesc").show();
		}else{
			$("#"+prefix+"portalDesc").hide();
		}
		
		// Iniciar el componente dirección de contacto
	//	console.log("Iniciar el componente");
	//	console.log(direccion);
		initDirComponentAutocomplete({
			"prefix": prefix,
			"direccion": direccion, 
			"pisoTutelado": false,
			"provinciasNoCAV":true,
			"callbacks": {
				"general": {
					"success": () => {}
				},
//				"localidad": {
//					"change": () => {
//						if($("#"+prefix+"idlocalidad06_detail_table").rup_autocomplete("getRupValue") == ''
//							|| $("#"+prefix+"idlocalidad06_detail_table_label").val() == ''){						
//							$("#"+prefix+"localidadDesc").show();
//						}else{
//							$("#"+prefix+"localidadDesc").hide();
//						}
//					},
//				},
//				"calle": {
//					"change": () => {
//						if($("#"+prefix+"idcalle06_detail_table").rup_autocomplete("getRupValue") == ''
//							|| $("#"+prefix+"idcalle06_detail_table_label").val() == ''){						
//							$("#"+prefix+"calleDesc").show();					
//							$("#"+prefix+"portalDesc").show();
//							$("#"+prefix+"calleNora").hide();
//							$("#"+prefix+"portaNora").hide();
//						}else{
//							$("#"+prefix+"calleDesc").hide();
//							$("#"+prefix+"portalDesc").hide();
//							$("#"+prefix+"calleNora").show();
//							$("#"+prefix+"portaNora").hide();
//						}
//					},
//				},
//				"portal": {
//					"change": () => {	
//						if($("#"+prefix+"idportal06_detail_table").rup_autocomplete("getRupValue") == ''
//							|| $("#"+prefix+"idportal06_detail_table_label").val() == ''){						
//							$("#"+prefix+"portalDesc").show();
//						}else{
//							$("#"+prefix+"portalDesc").hide();
//						}
//					},
//				}
						}
		});
	}
});